;===========================================================================================
; Bmpin1.asm  GoAsm assembler
; Charger un fichier binaire bitmap 16M de couleurs en mmoire et l'afficher  l'cran
; Le fichier binaire bitmap est intgr au fichier .exe
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\bmpin1.rc
; ..\..\bin\GoAsm bmpin1.asm
; ..\..\bin\GoLink bmpin1.obj res\bmpin1.res user32.dll kernel32.dll gdi32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  ID_FRANCE  = 17

  DIB_RGB_COLORS = 0h

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne spcifique
    ; ---------------------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur systme
    ; -------------------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Valider la structure WNDCLASS
    ; -----------------------------
    invoke RegisterClass,addr wc

    ; Cration de la fenetre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,0,addr ClassName,addr Titre,WS_CAPTION+WS_POPUP+WS_SYSMENU \
                         +WS_MINIMIZEBOX,[WinX],[WinY],[WinW],[WinH],0,0,[wc.hInstance],0
    mov [hWnd],eax

    ; Affiche et rafraichit la fenetre
    ; --------------------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT
    invoke UpdateWindow,[hWnd]

 ; Boucle des messages
 ; -------------------
 MessageLoop:
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi

    cmp D[@uMsg],WM_CLOSE
    jne >.wmcreate
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Supprime l'objet bitmap cre
        ; ----------------------------
        invoke DeleteObject,[hBitmap]

        ; Fin de l'application
        ; --------------------
        invoke PostQuitMessage,0
        jmp >>.exit

    .wmcreate:
    cmp D[@uMsg],WM_CREATE
    jne >.wmpaint
        ; Cration d'un dispositif bitmap indpendant
        ; -------------------------------------------
        mov ebx,addr ptBitmap                      ;addr BITMAPINFOHEADER
        invoke CreateDIBSection,0,ebx,DIB_RGB_COLORS,addr ppvBits,0,0
        mov [hBitmap],eax

        ; Copie le bitmap en mmoire
        ; --------------------------
        mov eax,addr ptBitmap+40                   ;addr src BitmapImage
        invoke MemCopy,eax,[ppvBits],[ebx+20]      ;BITMAPINFOHEADER.biSizeImage
        jmp >>.exit

    .wmpaint:
    cmp D[@uMsg],WM_PAINT
    jne >.defwindowproc
        ; Dbut dessin/criture
        ; ---------------------
        invoke BeginPaint,[@hWnd],addr ps
        mov [ps.hdc],eax

        ; Cration d'un contexte de dispositif mmoire compatible
        ; -------------------------------------------------------
        invoke CreateCompatibleDC,[ps.hdc]
        mov [hMemDC],eax

        ; Choisit un objet suivant le contexte de dispositif hmdc
        ; -------------------------------------------------------
        invoke SelectObject,eax,[hBitmap]

        ; Copie le bitmap de la mmoire vers la fenetre
        ; ---------------------------------------------
        mov ebx,addr ptBitmap                           ;addr BITMAPINFOHEADER
        invoke BitBlt,[ps.hdc],84,18,[ebx+4],[ebx+8],[hMemDC],0,0,SRCCOPY   

        ; Supprime le contexte de dispositif hMemDC
        ; -----------------------------------------
        invoke DeleteDC,[hMemDC]

        ; Fin dessin/criture
        ; -------------------
        invoke EndPaint,[@hWnd],addr ps
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; ------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:

    mov eax,0
    ret
endf

;===========================================================================================
; @AddrSrc  = adresse source de la zone mmoire  copier
; @AddrDest = adresse de destination de la copie
; @Size     = nombre d'octets  copier
;-------------------------------------------------------------------------------------------
MemCopy frame @AddrSrc, @AddrDest, @Size

    cld
    mov esi,[@AddrSrc]
    mov edi,[@AddrDest]
    mov ecx,[@Size]
    shr ecx,2
    rep movsd
    mov ecx,[@Size]
    and ecx,3
    rep movsb

    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  ptBitmap INCBIN res\Fyeah.bmp, 14                   ;atteindre adresse BITMAPINFOHEADER
  Titre      db ' Bitmap 16M from memory',0
  ClassName  db ' AsmGges Win32',0
  MsgEnd     db ' GoAsm AsmGges France @2006  ',0
  align 4

  WinX       dd 0
  WinY       dd 100
  WinW       dd 300
  WinH       dd 200

  hWnd       dd ?
  hBitmap    dd ?
  hMemDC     dd ?
  ppvBits    dd ?

  msg        MSG         <>
  wc         WNDCLASS    < 0,addr WindowProc, 0, 0, NULL, NULL, NULL,\
                           COLOR_WINDOW+1, NULL, addr ClassName >
  ps         PAINTSTRUCT <>

;===========================================================================================
